Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -2148,349 +2083,327 @@
        CALL cpu_log( log_point_s(85), 'NetCDF input init', 'start' )
 
-       DO  ii = 0, io_blocks-1
-          IF ( ii == io_group )  THEN
 #if defined ( __netcdf )
 !
-!--          Open file in read-only mode
-             CALL open_read_file( TRIM( input_file_dynamic ) //                &
-                                  TRIM( coupling_char ), id_dynamic )
-
-!
-!--          At first, inquire all variable names.
-             CALL inquire_num_variables( id_dynamic, num_vars )
-!
-!--          Allocate memory to store variable names.
-             ALLOCATE( var_names(1:num_vars) )
-             CALL inquire_variable_names( id_dynamic, var_names )
-!
-!--          Read vertical dimension of scalar und w grid. Will be used for
-!--          inter- and extrapolation in case of stretched numeric grid.
-!--          This will be removed when Inifor is able to handle stretched grids.
-             CALL get_dimension_length( id_dynamic, init_3d%nzu, 'z'     )
-             CALL get_dimension_length( id_dynamic, init_3d%nzw, 'zw'    )
-             CALL get_dimension_length( id_dynamic, init_3d%nzs, 'zsoil' )
-!
-!--          Read also the horizontal dimensions. These are used just used fo
-!--          checking the compatibility with the PALM grid before reading.
-             CALL get_dimension_length( id_dynamic, init_3d%nx,  'x'  )
-             CALL get_dimension_length( id_dynamic, init_3d%nxu, 'xu' )
-             CALL get_dimension_length( id_dynamic, init_3d%ny,  'y'  )
-             CALL get_dimension_length( id_dynamic, init_3d%nyv, 'yv' )
-
-!
-!--          Check for correct horizontal and vertical dimension. Please note,
-!--          checks are performed directly here and not called from
-!--          check_parameters as some varialbes are still not allocated there.
-!--          Moreover, please note, u- and v-grid has 1 grid point less on
-!--          Inifor grid.
-             IF ( init_3d%nx-1 /= nx  .OR.  init_3d%nxu-1 /= nx - 1  .OR.      &
-                  init_3d%ny-1 /= ny  .OR.  init_3d%nyv-1 /= ny - 1 )  THEN
-                message_string = 'Number of inifor horizontal grid points  '// &
-                                 'does not match the number of numeric grid '//&
-                                 'points.'
-                CALL message( 'netcdf_data_input_mod', 'NDI003', 1, 2, 0, 6, 0 )
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_dynamic ) //                      &
+                            TRIM( coupling_char ), id_dynamic )
+
+!
+!--    At first, inquire all variable names.
+       CALL inquire_num_variables( id_dynamic, num_vars )
+!
+!--    Allocate memory to store variable names.
+       ALLOCATE( var_names(1:num_vars) )
+       CALL inquire_variable_names( id_dynamic, var_names )
+!
+!--    Read vertical dimension of scalar und w grid. Will be used for
+!--    inter- and extrapolation in case of stretched numeric grid.
+!--    This will be removed when Inifor is able to handle stretched grids.
+       CALL get_dimension_length( id_dynamic, init_3d%nzu, 'z'     )
+       CALL get_dimension_length( id_dynamic, init_3d%nzw, 'zw'    )
+       CALL get_dimension_length( id_dynamic, init_3d%nzs, 'depth' )
+!
+!--    Read also the horizontal dimensions. These are used just used fo
+!--    checking the compatibility with the PALM grid before reading.
+       CALL get_dimension_length( id_dynamic, init_3d%nx,  'x'  )
+       CALL get_dimension_length( id_dynamic, init_3d%nxu, 'xu' )
+       CALL get_dimension_length( id_dynamic, init_3d%ny,  'y'  )
+       CALL get_dimension_length( id_dynamic, init_3d%nyv, 'yv' )
+
+!
+!--    Check for correct horizontal and vertical dimension. Please note,
+!--    checks are performed directly here and not called from
+!--    check_parameters as some varialbes are still not allocated there.
+!--    Moreover, please note, u- and v-grid has 1 grid point less on
+!--    Inifor grid.
+       IF ( init_3d%nx-1 /= nx  .OR.  init_3d%nxu-1 /= nx - 1  .OR.            &
+            init_3d%ny-1 /= ny  .OR.  init_3d%nyv-1 /= ny - 1 )  THEN
+          message_string = 'Number of inifor horizontal grid points  '//       &
+                           'does not match the number of numeric grid '//      &
+                           'points.'
+          CALL message( 'netcdf_data_input_mod', 'NDI003', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( init_3d%nzu-1 /= nz )  THEN
+          message_string = 'Number of inifor vertical grid points ' //         &
+                           'does not match the number of numeric grid '//      &
+                           'points.'
+          CALL message( 'netcdf_data_input_mod', 'NDI003', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    Read vertical dimensions. Later, these are required for eventual
+!--    inter- and extrapolations of the initialization data.
+       IF ( check_existence( var_names, 'z' ) )  THEN
+          ALLOCATE( init_3d%zu_atmos(1:init_3d%nzu) )
+          CALL get_variable( id_dynamic, 'z', init_3d%zu_atmos )
+       ENDIF
+       IF ( check_existence( var_names, 'zw' ) )  THEN
+          ALLOCATE( init_3d%zw_atmos(1:init_3d%nzw) )
+          CALL get_variable( id_dynamic, 'zw', init_3d%zw_atmos )
+       ENDIF
+       IF ( check_existence( var_names, 'depth' ) )  THEN
+          ALLOCATE( init_3d%z_soil(1:init_3d%nzs) )
+          CALL get_variable( id_dynamic, 'depth', init_3d%z_soil )
+       ENDIF
+!
+!--    Read initial geostrophic wind components at t = 0 (index 1 in file).
+!        IF ( check_existence( var_names, 'tend_ug' ) )  THEN
+       IF ( check_existence( var_names, 'ls_forcing_ug' ) )  THEN
+          ALLOCATE( init_3d%ug_init(nzb:nzt+1) )
+!           CALL get_variable_pr( id_dynamic, 'tend_ug', 1,                      &
+!                                 init_3d%ug_init )
+          CALL get_variable_pr( id_dynamic, 'ls_forcing_ug', 1,                &
+                                init_3d%ug_init )
+          init_3d%from_file_ug = .TRUE.
+       ELSE
+          init_3d%from_file_ug = .FALSE.
+       ENDIF
+!        IF ( check_existence( var_names, 'tend_vg' ) )  THEN
+       IF ( check_existence( var_names, 'ls_forcing_vg' ) )  THEN
+          ALLOCATE( init_3d%vg_init(nzb:nzt+1) )
+!           CALL get_variable_pr( id_dynamic, 'tend_vg', 1,                      &
+!                                 init_3d%vg_init )
+          CALL get_variable_pr( id_dynamic, 'ls_forcing_vg', 1,                &
+                                init_3d%vg_init )
+          init_3d%from_file_vg = .TRUE.
+       ELSE
+          init_3d%from_file_vg = .FALSE.
+       ENDIF
+!
+!--    Read inital 3D data of u, v, w, pt and q,
+!--    derived from COSMO model. Read PE-wise yz-slices.
+!--    Please note, the u-, v- and w-component are defined on different
+!--    grids with one element less in the x-, y-,
+!--    and z-direction, respectively. Hence, reading is subdivided
+!--    into separate loops.  
+!--    Read u-component
+       IF ( check_existence( var_names, 'init_u' ) )  THEN
+!
+!--       Read attributes for the fill value and level-of-detail
+          CALL get_attribute( id_dynamic, char_fill, init_3d%fill_u,           &
+                              .FALSE., 'init_u' )
+          CALL get_attribute( id_dynamic, char_lod, init_3d%lod_u,             &
+                              .FALSE., 'init_u' )
+!
+!--       level-of-detail 1 - read initialization profile
+          IF ( init_3d%lod_u == 1 )  THEN
+             ALLOCATE( init_3d%u_init(nzb:nzt+1) )
+             init_3d%u_init = 0.0_wp
+
+             CALL get_variable( id_dynamic, 'init_u',                          &
+                                init_3d%u_init(nzb+1:nzt+1) )
+!
+!--       level-of-detail 2 - read 3D initialization data
+          ELSEIF ( init_3d%lod_u == 2 )  THEN
+
+             CALL get_variable( id_dynamic, 'init_u',                          &
+                                u(nzb+1:nzt+1,nys:nyn,nxlu:nxr),               &
+                                nxlu, nys+1, nzb+1,                            &
+                                nxr-nxlu+1, nyn-nys+1, init_3d%nzu,            &
+                                dynamic_3d )
+          ENDIF
+          init_3d%from_file_u = .TRUE.
+       ENDIF
+!
+!--    Read v-component
+       IF ( check_existence( var_names, 'init_v' ) )  THEN
+!
+!--       Read attributes for the fill value and level-of-detail
+          CALL get_attribute( id_dynamic, char_fill, init_3d%fill_v,           &
+                              .FALSE., 'init_v' )
+          CALL get_attribute( id_dynamic, char_lod, init_3d%lod_v,             &
+                              .FALSE., 'init_v' )
+!
+!--       level-of-detail 1 - read initialization profile
+          IF ( init_3d%lod_v == 1 )  THEN
+             ALLOCATE( init_3d%v_init(nzb:nzt+1) )
+             init_3d%v_init = 0.0_wp
+
+             CALL get_variable( id_dynamic, 'init_v',                          &
+                                init_3d%v_init(nzb+1:nzt+1) )
+
+!
+!--       level-of-detail 2 - read 3D initialization data
+          ELSEIF ( init_3d%lod_v == 2 )  THEN
+
+             CALL get_variable( id_dynamic, 'init_v',                          &
+                                v(nzb+1:nzt+1,nysv:nyn,nxl:nxr),               &
+                                nxl+1, nysv, nzb+1,                            &
+                                nxr-nxl+1, nyn-nysv+1, init_3d%nzu,            &
+                                dynamic_3d )
+             
+          ENDIF
+          init_3d%from_file_v = .TRUE.
+       ENDIF
+!
+!--    Read w-component
+       IF ( check_existence( var_names, 'init_w' ) )  THEN
+!
+!--       Read attributes for the fill value and level-of-detail
+          CALL get_attribute( id_dynamic, char_fill, init_3d%fill_w,           &
+                              .FALSE., 'init_w' )
+          CALL get_attribute( id_dynamic, char_lod, init_3d%lod_w,             &
+                              .FALSE., 'init_w' )
+!
+!--       level-of-detail 1 - read initialization profile
+          IF ( init_3d%lod_w == 1 )  THEN
+             ALLOCATE( init_3d%w_init(nzb:nzt+1) )
+             init_3d%w_init = 0.0_wp
+
+             CALL get_variable( id_dynamic, 'init_w',                          &
+                                init_3d%w_init(nzb+1:nzt) )
+
+!
+!--       level-of-detail 2 - read 3D initialization data
+          ELSEIF ( init_3d%lod_w == 2 )  THEN
+
+             CALL get_variable( id_dynamic, 'init_w',                           &
+                                w(nzb+1:nzt,nys:nyn,nxl:nxr),                   &
+                                nxl+1, nys+1, nzb+1,                            &
+                                nxr-nxl+1, nyn-nys+1, init_3d%nzw,              &
+                                dynamic_3d )
+
+          ENDIF
+          init_3d%from_file_w = .TRUE.
+       ENDIF
+!
+!--    Read potential temperature
+       IF ( .NOT. neutral )  THEN
+          IF ( check_existence( var_names, 'init_pt' ) )  THEN
+!
+!--          Read attributes for the fill value and level-of-detail
+             CALL get_attribute( id_dynamic, char_fill, init_3d%fill_pt,       &
+                                 .FALSE., 'init_pt' )
+             CALL get_attribute( id_dynamic, char_lod, init_3d%lod_pt,         &
+                                 .FALSE., 'init_pt' )
+!
+!--          level-of-detail 1 - read initialization profile
+             IF ( init_3d%lod_pt == 1 )  THEN
+                ALLOCATE( init_3d%pt_init(nzb:nzt+1) )
+
+                CALL get_variable( id_dynamic, 'init_pt',                      &
+                                   init_3d%pt_init(nzb+1:nzt+1) )
+!
+!--             Set Neumann surface boundary condition for initial profil
+                init_3d%pt_init(nzb) = init_3d%pt_init(nzb+1)
+!
+!--          level-of-detail 2 - read 3D initialization data
+             ELSEIF ( init_3d%lod_pt == 2 )  THEN
+
+                CALL get_variable( id_dynamic, 'init_pt',                      &
+                                   pt(nzb+1:nzt+1,nys:nyn,nxl:nxr),            &
+                                   nxl+1, nys+1, nzb+1,                        &
+                                   nxr-nxl+1, nyn-nys+1, init_3d%nzu,          &
+                                   dynamic_3d )
+
+
              ENDIF
-
-             IF ( init_3d%nzu-1 /= nz )  THEN
-                message_string = 'Number of inifor vertical grid points ' //   &
-                                 'does not match the number of numeric grid '//&
-                                 'points.'
-                CALL message( 'netcdf_data_input_mod', 'NDI003', 1, 2, 0, 6, 0 )
+             init_3d%from_file_pt = .TRUE.
+          ENDIF
+       ENDIF
+!
+!--    Read mixing ratio
+       IF ( humidity )  THEN
+          IF ( check_existence( var_names, 'init_qv' ) )  THEN
+!
+!--          Read attributes for the fill value and level-of-detail
+             CALL get_attribute( id_dynamic, char_fill, init_3d%fill_q,        &
+                                 .FALSE., 'init_qv' )
+             CALL get_attribute( id_dynamic, char_lod, init_3d%lod_q,          &
+                                 .FALSE., 'init_qv' )
+!
+!--          level-of-detail 1 - read initialization profile
+             IF ( init_3d%lod_q == 1 )  THEN
+                ALLOCATE( init_3d%q_init(nzb:nzt+1) )
+
+                CALL get_variable( id_dynamic, 'init_qv',                      &
+                                   init_3d%q_init(nzb+1:nzt+1) )
+!
+!--             Set Neumann surface boundary condition for initial profil
+                init_3d%q_init(nzb) = init_3d%q_init(nzb+1)
+
+!
+!--          level-of-detail 2 - read 3D initialization data
+             ELSEIF ( init_3d%lod_q == 2 )  THEN
+             
+                CALL get_variable( id_dynamic, 'init_qv',                      &
+                                   q(nzb+1:nzt+1,nys:nyn,nxl:nxr),             &
+                                   nxl+1, nys+1, nzb+1,                        &
+                                   nxr-nxl+1, nyn-nys+1, init_3d%nzu,          &
+                                   dynamic_3d )
+
+
+
              ENDIF
-!
-!--          Read vertical dimensions. Later, these are required for eventual
-!--          inter- and extrapolations of the initialization data.
-             IF ( check_existence( var_names, 'z' ) )  THEN
-                ALLOCATE( init_3d%zu_atmos(1:init_3d%nzu) )
-                CALL get_variable( id_dynamic, 'z', init_3d%zu_atmos )
+             init_3d%from_file_q = .TRUE.
+          ENDIF
+       ENDIF
+!
+!--    Read soil moisture
+       IF ( land_surface )  THEN
+
+          IF ( check_existence( var_names, 'init_soil_m' ) )  THEN
+!
+!--          Read attributes for the fill value and level-of-detail
+             CALL get_attribute( id_dynamic, char_fill,                        &
+                                 init_3d%fill_msoil,                           &
+                                 .FALSE., 'init_soil_m' )
+             CALL get_attribute( id_dynamic, char_lod,                         &
+                                 init_3d%lod_msoil,                            &
+                                 .FALSE., 'init_soil_m' )
+!
+!--          level-of-detail 1 - read initialization profile
+             IF ( init_3d%lod_msoil == 1 )  THEN
+                ALLOCATE( init_3d%msoil_init(0:init_3d%nzs-1) )
+
+                CALL get_variable( id_dynamic, 'init_soil_m',                  &
+                                   init_3d%msoil_init(0:init_3d%nzs-1) )
+!
+!--          level-of-detail 2 - read 3D initialization data
+             ELSEIF ( init_3d%lod_msoil == 2 )  THEN
+                ALLOCATE ( init_3d%msoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
+
+               CALL get_variable( id_dynamic, 'init_soil_m',                   &   
+                                  init_3d%msoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr),&
+                                  nxl, nxr, nys, nyn, 0, init_3d%nzs-1 )
+
              ENDIF
-             IF ( check_existence( var_names, 'zw' ) )  THEN
-                ALLOCATE( init_3d%zw_atmos(1:init_3d%nzw) )
-                CALL get_variable( id_dynamic, 'zw', init_3d%zw_atmos )
+             init_3d%from_file_msoil = .TRUE.
+          ENDIF
+!
+!--       Read soil temperature
+          IF ( check_existence( var_names, 'init_soil_t' ) )  THEN
+!
+!--          Read attributes for the fill value and level-of-detail
+             CALL get_attribute( id_dynamic, char_fill,                        &
+                                 init_3d%fill_tsoil,                           &
+                                 .FALSE., 'init_soil_t' )
+             CALL get_attribute( id_dynamic, char_lod,                         &
+                                 init_3d%lod_tsoil,                            &
+                                 .FALSE., 'init_soil_t' )
+!
+!--          level-of-detail 1 - read initialization profile
+             IF ( init_3d%lod_tsoil == 1 )  THEN
+                ALLOCATE( init_3d%tsoil_init(0:init_3d%nzs-1) )
+
+                CALL get_variable( id_dynamic, 'init_soil_t',                  &
+                                   init_3d%tsoil_init(0:init_3d%nzs-1) )
+
+!
+!--          level-of-detail 2 - read 3D initialization data
+             ELSEIF ( init_3d%lod_tsoil == 2 )  THEN
+                ALLOCATE ( init_3d%tsoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
+                
+                CALL get_variable( id_dynamic, 'init_soil_t',                  &   
+                                  init_3d%tsoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr),&
+                                  nxl, nxr, nys, nyn, 0, init_3d%nzs-1 )
              ENDIF
-             IF ( check_existence( var_names, 'zsoil' ) )  THEN
-                ALLOCATE( init_3d%z_soil(1:init_3d%nzs) )
-                CALL get_variable( id_dynamic, 'zsoil', init_3d%z_soil )
-             ENDIF
-!
-!--          Read initial geostrophic wind components at
-!--          t = 0 (index 1 in file).
-             IF ( check_existence( var_names, 'tend_ug' ) )  THEN
-                ALLOCATE( init_3d%ug_init(nzb:nzt+1) )
-                CALL get_variable_pr( id_dynamic, 'tend_ug', 1,                &
-                                      init_3d%ug_init )
-                init_3d%from_file_ug = .TRUE.
-             ELSE
-                init_3d%from_file_ug = .FALSE.
-             ENDIF
-             IF ( check_existence( var_names, 'tend_vg' ) )  THEN
-                ALLOCATE( init_3d%vg_init(nzb:nzt+1) )
-                CALL get_variable_pr( id_dynamic, 'tend_vg', 1,                &
-                                      init_3d%vg_init )
-                init_3d%from_file_vg = .TRUE.
-             ELSE
-                init_3d%from_file_vg = .FALSE.
-             ENDIF
-!
-!--          Read inital 3D data of u, v, w, pt and q,
-!--          derived from COSMO model. Read PE-wise yz-slices.
-!--          Please note, the u-, v- and w-component are defined on different
-!--          grids with one element less in the x-, y-,
-!--          and z-direction, respectively. Hence, reading is subdivided
-!--          into separate loops. Moreover, i and j are used
-!--          as start index in the NF90 interface.
-!--          The passed arguments for u, and v are (i,j)-1, respectively,
-!--          in contrast to the remaining quantities. This is because in case
-!--          of forcing is applied, the input data for u and v has one
-!--          element less along the x- and y-direction respectively.
-!--          Read u-component
-             IF ( check_existence( var_names, 'init_u' ) )  THEN
-!
-!--             Read attributes for the fill value and level-of-detail
-                CALL get_attribute( id_dynamic, char_fill, init_3d%fill_u,     &
-                                    .FALSE., 'init_u' )
-                CALL get_attribute( id_dynamic, char_lod, init_3d%lod_u,       &
-                                    .FALSE., 'init_u' )
-!
-!--             level-of-detail 1 - read initialization profile
-                IF ( init_3d%lod_u == 1 )  THEN
-                   ALLOCATE( init_3d%u_init(nzb:nzt+1) )
-                   init_3d%u_init = 0.0_wp
-
-                   CALL get_variable( id_dynamic, 'init_u',                    &
-                                      init_3d%u_init(nzb+1:nzt+1) )
-!
-!--             level-of-detail 2 - read 3D initialization data
-                ELSEIF ( init_3d%lod_u == 2 )  THEN
-!
-!--                Set offset value. In case of Dirichlet conditions at the left
-!--                domain boundary, the u component starts at nxl+1. This case,
-!--                the passed start-index for reading the NetCDF data is shifted
-!--                by -1.
-                   off_i = 1 !MERGE( 1, 0, forcing )
-
-                   DO  i = nxlu, nxr
-                      DO  j = nys, nyn
-                         CALL get_variable( id_dynamic, 'init_u', i-off_i, j,  &
-                                            u(nzb+1:nzt+1,j,i) )
-                      ENDDO
-                   ENDDO
-
-                ENDIF
-                init_3d%from_file_u = .TRUE.
-             ENDIF
-!
-!--          Read v-component
-             IF ( check_existence( var_names, 'init_v' ) )  THEN
-!
-!--             Read attributes for the fill value and level-of-detail
-                CALL get_attribute( id_dynamic, char_fill, init_3d%fill_v,     &
-                                    .FALSE., 'init_v' )
-                CALL get_attribute( id_dynamic, char_lod, init_3d%lod_v,       &
-                                    .FALSE., 'init_v' )
-!
-!--             level-of-detail 1 - read initialization profile
-                IF ( init_3d%lod_v == 1 )  THEN
-                   ALLOCATE( init_3d%v_init(nzb:nzt+1) )
-                   init_3d%v_init = 0.0_wp
-
-                   CALL get_variable( id_dynamic, 'init_v',                    &
-                                      init_3d%v_init(nzb+1:nzt+1) )
-
-!
-!--             level-of-detail 2 - read 3D initialization data
-                ELSEIF ( init_3d%lod_v == 2 )  THEN
-!
-!--                Set offset value. In case of Dirichlet conditions at the south
-!--                domain boundary, the v component starts at nys+1. This case,
-!--                the passed start-index for reading the NetCDF data is shifted
-!--                by -1.
-                   off_j = 1 !MERGE( 1, 0, forcing )
-
-                   DO  i = nxl, nxr
-                      DO  j = nysv, nyn
-                         CALL get_variable( id_dynamic, 'init_v', i, j-off_j,  &
-                                            v(nzb+1:nzt+1,j,i) )
-                      ENDDO
-                   ENDDO
-
-                ENDIF
-                init_3d%from_file_v = .TRUE.
-             ENDIF
-!
-!--          Read w-component
-             IF ( check_existence( var_names, 'init_w' ) )  THEN
-!
-!--             Read attributes for the fill value and level-of-detail
-                CALL get_attribute( id_dynamic, char_fill, init_3d%fill_w,     &
-                                    .FALSE., 'init_w' )
-                CALL get_attribute( id_dynamic, char_lod, init_3d%lod_w,       &
-                                    .FALSE., 'init_w' )
-!
-!--             level-of-detail 1 - read initialization profile
-                IF ( init_3d%lod_w == 1 )  THEN
-                   ALLOCATE( init_3d%w_init(nzb:nzt+1) )
-                   init_3d%w_init = 0.0_wp
-
-                   CALL get_variable( id_dynamic, 'init_w',                    &
-                                      init_3d%w_init(nzb+1:nzt) )
-
-!
-!--             level-of-detail 2 - read 3D initialization data
-                ELSEIF ( init_3d%lod_w == 2 )  THEN
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         CALL get_variable( id_dynamic, 'init_w', i, j,        &
-                                            w(nzb+1:nzt,j,i) )
-                      ENDDO
-                   ENDDO
-
-                ENDIF
-                init_3d%from_file_w = .TRUE.
-             ENDIF
-!
-!--          Read potential temperature
-             IF ( .NOT. neutral )  THEN
-                IF ( check_existence( var_names, 'init_pt' ) )  THEN
-!
-!--                Read attributes for the fill value and level-of-detail
-                   CALL get_attribute( id_dynamic, char_fill, init_3d%fill_pt, &
-                                       .FALSE., 'init_pt' )
-                   CALL get_attribute( id_dynamic, char_lod, init_3d%lod_pt,   &
-                                       .FALSE., 'init_pt' )
-!
-!--                level-of-detail 1 - read initialization profile
-                   IF ( init_3d%lod_pt == 1 )  THEN
-                      ALLOCATE( init_3d%pt_init(nzb:nzt+1) )
-
-                      CALL get_variable( id_dynamic, 'init_pt',                &
-                                         init_3d%pt_init(nzb+1:nzt+1) )
-!
-!--                   Set Neumann surface boundary condition for initial profil
-                      init_3d%pt_init(nzb) = init_3d%pt_init(nzb+1)
-!
-!--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_pt == 2 )  THEN
-                      DO  i = nxl, nxr
-                         DO  j = nys, nyn
-                            CALL get_variable( id_dynamic, 'init_pt', i, j,    &
-                                               pt(nzb+1:nzt+1,j,i) )
-                         ENDDO
-                      ENDDO
-
-                   ENDIF
-                   init_3d%from_file_pt = .TRUE.
-                ENDIF
-             ENDIF
-!
-!--          Read mixing ratio
-             IF ( humidity )  THEN
-                IF ( check_existence( var_names, 'init_qv' ) )  THEN
-!
-!--                Read attributes for the fill value and level-of-detail
-                   CALL get_attribute( id_dynamic, char_fill, init_3d%fill_q,  &
-                                       .FALSE., 'init_qv' )
-                   CALL get_attribute( id_dynamic, char_lod, init_3d%lod_q,    &
-                                       .FALSE., 'init_qv' )
-!
-!--                level-of-detail 1 - read initialization profile
-                   IF ( init_3d%lod_q == 1 )  THEN
-                      ALLOCATE( init_3d%q_init(nzb:nzt+1) )
-
-                      CALL get_variable( id_dynamic, 'init_qv',               &
-                                         init_3d%q_init(nzb+1:nzt+1) )
-!
-!--                   Set Neumann surface boundary condition for initial profil
-                      init_3d%q_init(nzb) = init_3d%q_init(nzb+1)
-
-!
-!--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_q == 2 )  THEN
-                      DO  i = nxl, nxr
-                         DO  j = nys, nyn
-                            CALL get_variable( id_dynamic, 'init_qv', i, j,    &
-                                               q(nzb+1:nzt+1,j,i) )
-                         ENDDO
-                      ENDDO
-
-                   ENDIF
-                   init_3d%from_file_q = .TRUE.
-                ENDIF
-             ENDIF
-!
-!--          Read soil moisture
-             IF ( land_surface )  THEN
-
-                IF ( check_existence( var_names, 'init_soil_m' ) )  THEN
-!
-!--                Read attributes for the fill value and level-of-detail
-                   CALL get_attribute( id_dynamic, char_fill,                  &
-                                       init_3d%fill_msoil,                     &
-                                       .FALSE., 'init_soil_m' )
-                   CALL get_attribute( id_dynamic, char_lod,                   &
-                                       init_3d%lod_msoil,                      &
-                                       .FALSE., 'init_soil_m' )
-!
-!--                level-of-detail 1 - read initialization profile
-                   IF ( init_3d%lod_msoil == 1 )  THEN
-                      ALLOCATE( init_3d%msoil_init(0:init_3d%nzs-1) )
-
-                      CALL get_variable( id_dynamic, 'init_soil_m',            &
-                                         init_3d%msoil_init(0:init_3d%nzs-1) )
-!
-!--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_msoil == 2 )  THEN
-                      ALLOCATE ( init_3d%msoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
-                      DO  i = nxl, nxr
-                         DO  j = nys, nyn
-                            CALL get_variable( id_dynamic, 'init_soil_m', i, j,&
-                                               init_3d%msoil(0:init_3d%nzs-1,j,i) )
-                         ENDDO
-                      ENDDO
-                   ENDIF
-                   init_3d%from_file_msoil = .TRUE.
-                ENDIF
-!
-!--             Read soil temperature
-                IF ( check_existence( var_names, 'init_soil_t' ) )  THEN
-!
-!--                Read attributes for the fill value and level-of-detail
-                   CALL get_attribute( id_dynamic, char_fill,                  &
-                                       init_3d%fill_tsoil,                     &
-                                       .FALSE., 'init_soil_t' )
-                   CALL get_attribute( id_dynamic, char_lod,                   &
-                                       init_3d%lod_tsoil,                      &
-                                       .FALSE., 'init_soil_t' )
-!
-!--                level-of-detail 1 - read initialization profile
-                   IF ( init_3d%lod_tsoil == 1 )  THEN
-                      ALLOCATE( init_3d%tsoil_init(0:init_3d%nzs-1) )
-
-                      CALL get_variable( id_dynamic, 'init_soil_t',            &
-                                         init_3d%tsoil_init(0:init_3d%nzs-1) )
-
-!
-!--                level-of-detail 2 - read 3D initialization data
-                   ELSEIF ( init_3d%lod_tsoil == 2 )  THEN
-                      ALLOCATE ( init_3d%tsoil(0:init_3d%nzs-1,nys:nyn,nxl:nxr) )
-                      DO  i = nxl, nxr
-                         DO  j = nys, nyn
-                            CALL get_variable( id_dynamic, 'init_soil_t', i, j,&
-                                               init_3d%tsoil(0:init_3d%nzs-1,j,i) )
-                         ENDDO
-                      ENDDO
-                   ENDIF
-                   init_3d%from_file_tsoil = .TRUE.
-                ENDIF
-             ENDIF
-!
-!--          Close input file
-             CALL close_input_file( id_dynamic )
+             init_3d%from_file_tsoil = .TRUE.
+          ENDIF
+       ENDIF
+!
+!--    Close input file
+       CALL close_input_file( id_dynamic )
 #endif
-          ENDIF
-#if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       ENDDO
 !
 !--    End of CPU measurement
@@ -2604,7 +2517,7 @@
        IMPLICIT NONE
 
-
+       LOGICAL      ::  dynamic_3d = .TRUE. !< flag indicating that 3D data is read from dynamic file
+       
        INTEGER(iwp) ::  i          !< running index along x-direction
-       INTEGER(iwp) ::  ii         !< running index for IO blocks
        INTEGER(iwp) ::  id_dynamic !< NetCDF id of dynamic input file
        INTEGER(iwp) ::  j          !< running index along y-direction
